DEF Endbuffer = -3:      -- token to flush buffers
CHAN Screen at 1: -- channel to screen
CHAN Keyboard at 2: -- channel to keyboard

PROC andgate(VALUE n,CHAN in[],Out)=
--
-- modelling n input AND gate
--
  VAR inp[10] : -- note array bound must be a constant
  SEQ -- or a symbol defined as a constant
    SEQ i=[0 FOR n] -- input places initialled
      inp[i]:=0
    WHILE TRUE
      VAR temp :
      SEQ
        temp:=1
        SEQ j=[0 FOR n]
          temp:=temp/\inp[j]   -- calc new output
        out!temp             -- and send out
        ALT i=[0 FOR n]
          in[i]?inp[i]         -- wait for new input
            SKIP    :
          :
PROC input(CHAN out1, out2)=
  WHILE TRUE
    VAR char :
    SEQ
      Keyboard?char -- get char from keyboard
      Screen!char -- echo it
      Screen!Endbuffer -- flush screen buffer
      outl!(char-'0') -- convert to integer
      Keyboard?char
      Screen!char
      Screen!Endbuffer
      out2!(char-'0')    :

Proc output(CHAN out)=
  WHILE TRUE
    VAR char :
    SEQ
       out?char -- get char to output
       Screen!(char+'0') -- send ASCII code to screen
       Screen!Endbuffer    :

CHAN i[2],o   : -- defining channels between processes
PAR -- all processes running in parallel
  andgate(2,i,o)
  input(i[0],i[1])
  output(o)
