DEF d=... : -- set to number of slots in the buffer
CHAN pw,vw,pr,vr,xr,xw : -- permission to read and
                         -- terminated reading,permission
                         -- to write and terminated writing,
                         -- read index and write index

- communication access

VAR b[d] : -- d slot buffer
PAR
  PAR
     VAR k : -- count of no. in buffer
     SEQ
        k:=0
        WHILE TRUE
           ALT
             k<d & pw?ANY   -- req to write and slot empty
               SKIP
             vw?ANY         -- req to terminate writing
               k:=k+1
             k>0 & pr?ANY   -- req to read and slot full
               SKIP
             vr?ANY         -- req to terminate reading
               k:=k-1
        -- write index
        VAR t :
        SEQ
          t:=0
          WHILE TRUE
             SEQ
               xw!t         -- send next write index to use
               t:=(t+1)\d   -- increment index
        -- read index
        VAR h :
        SEQ
          h:=0
          WHILE TRUE
             SEQ
                xr!h       -- send next read index to use
                h:=(h+1)\d -- increment index

     -- interface protocols

     PROC put(VALUE v)=
       VAR i :
       SEQ
          pw!ANY           -- permission to write
          xw?i             -- obtain slot index
          b[i]:=v          -- put value into buffer
          vw!ANY :         -- signal end of write

     PROC get(VAR v)=
       VAR i :
        SEQ
           pr!ANY          -- permission to read
           xr?i            -- obtain slot index
           v:=b[i]         -- get value from buffer
           vr!ANY :        -- signal end of read

      -- client processes
      PAR
        VAR x :
        ....put(x)....

        VAR y :
        ....get(y)....
