DEF empty =...                             -- initial value held in nodes
DEF iackpos =...                           -- positive response to i command
DEF cackpos =...                           -- positive response to c command
DEF cackneg =...                           -- negative response to c command
DEF n =...                                 -- maximum number of nodes
CHAN down[n],up[n] :
PAR
   PAR i=[0 FOR n]                         -- for all the nodes in the tree
       DEF lchild = l2*i) + 1 :            -- left child pointer
       DEF rchild = lchild + 1 :           -- right child pointer
       VAR val :
       SEQ
         val := empty                      -- initial value of node
         WHILE TRUE
            VAR v,ans,cmnd
            SEQ
                ALT                        -- accept input
                   down[i]?cmnd            -- command from father
                       IF
                         cmnd='p'
                             IF
                                val=empty
                                   up[i]!'p';0   --reply end of print
                                TRUE
                                   down[lchild]!'p'  -- left subtree
                         cmnd='i'
                             SEQ
                                   down[i]?v
                                   IF
                                       val=empty    -- empty node
                                         SEQ
                                            val=v   -- store value
                                            up[i]!iackpos;v  -- pos reply
                                       v<val          -- search left subtree
                                         SEQ
                                            down[lchild)!'i';v
                                       TRUE           -- search right subtree
                                         SEQ
                                            down[rchild]!'i';v
                         cmnd= 'c'                -- check command
                            SEQ
                               down[i]?v
                               IF
                                  val=empty       -- node empty
                                     up[i]!cackneg;v   -- neg reply
                                  val=v
                                     up[i]!cackpos;v   -- pos reply
                                  v<val                -- search left subtree
                                     SEQ
                                        down[lchild]!'c';v
                                  TRUE                 -- search right subtree
                                     SEQ
                                        down[rchild]!'c';v
                   up[left]?ans                  -- answer from left child
                      SEQ
                          up[left]?val
                          IF
                             ans='p'             -- if token reply
                                SEQ
                                  up[i)!0;val    -- send value
                                  down[right]:'p'-- and token right
                             TRUE
                                up[i]!ans;val    -- else send reply
                   up[right]?ans                 -- ans from right child
                      SEQ
                          up[right]?val
                          up[i]!ans;val          -- send reply to father
--
-- interface process
--
--
VAR ans,val,checkallowed,printallowed,insertallowed :
SEQ
  checkallowed := TRUE
  printallowed := TRUE
  insertallowed := TRUE
  ALT
     ALT i=[0 FOR n]
        insertallowed & ini[i]?ANY
          -- set checkallowed and printallowed to FALSE
          -- send command to root of tree
        checkallowed & inc[i]?ANY
          -- set insertallowed to be FALSE
          -- send command to root of tree
        printallowed & inp[i]?ANY
          -- set printallowed and insertallowed to FALSE
          -- send command to root of tree
     ALT
        intree?reply
          -- update insertallowed, printallowed and
          -- checkallowed as necessary
          -- send reply to client
